<?php
// set your timezone
date_default_timezone_set('America/New_York');

// pull in the packages managed by Composer
require_once("vendor/autoload.php");

use PHRETS\Configuration;
use PHRETS\Session;

// Configuration array
$configArray = [
    'login_url' => 'https://reb.retsiq.com/contactres/rets/login',
    'username' => 'RETSVIRANI',
    'password' => 'W43tXN7dMghDjjP',
    'rets_version' => '1.7.2',
    'http_authentication' => 'basic',
];

// Load the configuration
$config = Configuration::load($configArray);

// Get a session ready using the configuration
$rets = new Session($config);
$bulletin = $rets->Login();


$results = $rets->Search('Property', 'RD_1', '*', ['Limit' => 1,]);
$data = [];

foreach ($results as $r) {
    $search = $r->toArray();
    $objects = $rets->GetObject('Property', 'Photo', $search['L_ListingID'] . ':*', '*', 1);
    
    // Initialize an array to store data for this property
    $propertyData = [
        'search_result' => $search,
        'object_locations' => [],
    ];
    
    // Collect object locations for this property
    foreach ($objects as $object) {
        $propertyData['object_locations'][] = $object->getLocation();
    }
    
    // Store the collected data for this property
    $data[] = (object)$propertyData;
}

// Convert $data array to JSON format
$jsonData = json_encode(array_map(function($item) {
    return (array)$item;
}, $data));

var_dump($jsonData);

exit;


$fields = $rets->GetTableMetadata('Property', 'RD_1');

$tableData = [];

foreach ($fields as $field) {
    $tableData[] = [
        // 'Version' => $field->getVersion(),
        // 'Date' => $field->getDate(),
        // 'Resource' => $field->getResource(),
        // 'Class' => $field->getClass(),
        'SystemName' => $field->getSystemName(),
        'StandardName' => $field->getStandardName(),
        // 'LongName' => $field->getLongName(),
        // 'DBName' => $field->getDBName(),
        // 'ShortName' => $field->getShortName(),
        // 'MaximumLength' => $field->getMaximumLength(),
        // 'DataType' => $field->getDataType(),
        // 'Precision' => $field->getPrecision(),
        // 'Searchable' => $field->getSearchable(),
        // 'Interpretation' => $field->getInterpretation(),
        // 'Alignment' => $field->getAlignment(),
        // 'UseSeparator' => $field->getUseSeparator(),
        // 'EditMaskID' => $field->getEditMaskID(),
        // 'LookupName' => $field->getLookupName(),
        // 'MaxSelect' => $field->getMaxSelect(),
        // 'Units' => $field->getUnits(),
        // 'Index' => $field->getIndex(),
        // 'Minimum' => $field->getMinimum(),
        // 'Maximum' => $field->getMaximum(),
        // 'Default' => $field->getDefault(),
        // 'Required' => $field->getRequired(),
        // 'SearchHelpID' => $field->getSearchHelpID(),
        // 'Unique' => $field->getUnique(),
        // 'MetadataEntryID' => $field->getMetadataEntryID(),
        // 'ModTimeStamp' => $field->getModTimeStamp(),
        // 'ForeignKeyName' => $field->getForeignKeyName(),
        // 'ForeignField' => $field->getForeignField(),
        // 'InKeyIndex' => $field->getInKeyIndex()
    ];
}

// Now $tableData is an array containing the required data from each object in the collection

var_dump(json_encode($tableData));
// exit;

$results = $rets->Search('Property', 'RD_1', '*', ['Limit' => 1,]);
$data = [];

foreach ($results as $r) {
    $search = $r->toArray();
    $objects = $rets->GetObject('Property', 'Photo', $search['L_ListingID'] . ':*', '*', 1);
    
    $propertyData = [
        'search_result' => $search,
        'object_locations' => [],
    ];
    
    foreach ($objects as $object) {
        $propertyData['object_locations'][] = $object->getLocation();
    }
    
    $data[] = (object)$propertyData;
}

$jsonData = json_encode(array_map(function($item) {
    return (array)$item;
}, $data));

var_dump($jsonData);







// $system = $rets->Logout();
// var_dump($system);

// $objects = $rets->GetObject($rets_resource, $object_type, $object_keys);

// print_r($objects);exit;

// // grab the first object of the set
// $objects->first();

// // grab the last object of the set
// $objects->last();

// // throw out everything but the first 10 objects
// $objects = $objects->slice(0, 10);